# -*- coding:Utf-8 -*-
# ./addons/eventscripts/_libs/python/messiah93lib.py

'''
	=================================[ Code par Messiah93 ]=================================
	* Nom du script : messiah93lib-ESPython                                                *
	* Requis        : EventScripts - Source Python Extensions                              *
	* Version       : v0.15a                                                               *
	* Auteur        : Messiah93                                                            *
	* WebSite       : http://messiah93.com/                                                *
	* Page internet : http://messiah93.com/                                                *
	* Licence       : None                                                                 *
	=================================[ Code par Messiah93 ]=================================
'''

import es
import spe
import playerlib
import gamethread

VERSION = "0.15a"

def getVersion ():
	return VERSION

def regTickrate (typx):
	es.addons.registerTickListener(typx)

def unregTickrate (typx):
	es.addons.unregisterTickListener(typx)

def forceMapEnd ():
	userid = es.getuserid()
	es.server.insertcmd ("es_xgive %s game_end" % userid)
	es.server.insertcmd ("es_xfire %s game_end EndGame" % userid) 

def getPlayerScore (userid):
	pPlayer = playerlib.getPlayer(userid)
	return int(pPlayer.get("kills"))

def godPlayer (userid):
	es.setplayerprop(userid, "CCSPlayer.baseclass.m_lifeState", 0)

def killablePlayer (userid):
	es.setplayerprop(userid, "CCSPlayer.baseclass.m_lifeState", 512)

def spawnPlayer (userid):
	es.setplayerprop(userid, "CCSPlayer.m_iPlayerState", 0)
	es.setplayerprop(userid, "CCSPlayer.baseclass.m_lifeState", 512)
	es.spawnplayer(userid)

def killPlayer (userid):
	es.server.insertcmd ("es_xfire %s !self sethealth 0" % userid)

def createServerVariable (typx, name, value):
	rt = es.ServerVar(name, value)
	return typx(rt)

def removeIdleWeapons ():
	entityList = es.createentitylist()
	for entityIndex in entityList:
		if entityList[entityIndex]["classname"].startswith("weapon_"):
			if int(es.getindexprop(entityIndex, "CBaseEntity.m_hOwnerEntity")) == -1:
				spe.call("Remove", spe.getEntityOfIndex(entityIndex))

def removeRagdolls ():
	ragdollsList = es.createentitylist("cs_ragdoll")
	for ragdollsIndex in ragdollsList:
		spe.call("Remove", spe.getEntityOfIndex(ragdollsIndex))

def dropWeapons (userid, weapon):
	pass

def restartGame (i, msg='La partie recommence !'):
	es.server.insertcmd ("mp_restartgame %i" % i)
	gamethread.delayed(0.50, es.server.insertcmd, ("es_xcentermsg %s" % msg))

def endRoundForce (baseCheat):
	es.flags("remove", "cheat", "endround")
	gamethread.queue(es.server.insertcmd, ("endround"))
	if baseCheat == True:
		es.flags("add", "cheat", "endround")